import { DataSource } from 'apollo-datasource';
import type { Queue as BullQueue, JobCounts, JobStatus, JobId } from 'bull';
import { CreateJobInput, MutationCleanQueueArgs, MutationCloseQueueArgs, MutationDiscardJobArgs, MutationEmptyQueueArgs, MutationLogArgs, MutationMoveJobToCompletedArgs, MutationMoveJobToFailedArgs, MutationPromoteJobArgs, MutationRemoveJobArgs, MutationRemoveJobsByPatternArgs, MutationResumeQueueArgs, MutationRetryJobArgs, MutationUpdateJobDataArgs, OrderEnum } from '../../typings/gql';
import redisInfo from 'redis-info';
declare type Maybe<T> = T | undefined;
export declare class BullDataSource extends DataSource {
    private _queues;
    private _queuesMap;
    constructor(_queues: BullQueue[]);
    private _convertQueuesToMap;
    getQueueByName(name: string): BullQueue<any> | undefined;
    getQueues(): BullQueue[];
    createJob({ queue: queueName, name, data, options, }: CreateJobInput): Promise<import("bull").Job<any> | undefined>;
    getQueueJobs({ queue, limit, offset, status, id, order, }: {
        status: JobStatus[];
        queue: string;
        limit?: number;
        offset?: number;
        order?: OrderEnum;
        id?: JobId;
    }): Promise<import("bull").Job<any>[] | undefined>;
    getJob(queueName: string, id: JobId): Promise<import("bull").Job<any> | null | undefined>;
    getJobLogs(queueName: string, id: number): Promise<{
        logs: string[];
        count: number;
    } | undefined>;
    createJobLog(args: MutationLogArgs): Promise<import("bull").Job<any> | null | undefined>;
    retryJob(args: MutationRetryJobArgs): Promise<import("bull").Job<any> | null | undefined>;
    removeJobById(args: MutationRemoveJobArgs): Promise<import("bull").Job<any> | null | undefined>;
    moveJobToCompleted(args: MutationMoveJobToCompletedArgs): Promise<import("bull").Job<any> | null | undefined>;
    moveJobToFailed(args: MutationMoveJobToFailedArgs): Promise<import("bull").Job<any> | null | undefined>;
    promoteJob(args: MutationPromoteJobArgs): Promise<import("bull").Job<any> | null | undefined>;
    discardJob(args: MutationDiscardJobArgs): Promise<import("bull").Job<any> | null | undefined>;
    updateJobData(args: MutationUpdateJobDataArgs): Promise<import("bull").Job<any> | null | undefined>;
    getQueueJobsCounts(name: string): Promise<Maybe<JobCounts>>;
    pauseQueue(name: string): Promise<BullQueue<any> | undefined>;
    cleanQueue(args: MutationCleanQueueArgs): Promise<import("bull").Job<any>[] | undefined>;
    emptyQueue(args: MutationEmptyQueueArgs): Promise<BullQueue<any> | undefined>;
    closeQueue(args: MutationCloseQueueArgs): Promise<BullQueue<any> | undefined>;
    resumeQueue(args: MutationResumeQueueArgs): Promise<BullQueue<any> | undefined>;
    getQueueWaitingOrDelayedJobsCount(name: string): Promise<Maybe<number>>;
    removeJobsByPattern(args: MutationRemoveJobsByPatternArgs): Promise<boolean>;
    getRedisInfo(): Promise<redisInfo.RedisInfo | null>;
}
export {};
